#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char mksrc(FILE *fpr, FILE *fpw);

unsigned char funcName(unsigned char c)
{
	if ('0' <= c && c <= '9') goto fin;
	if ('A' <= c && c <= 'Z') goto fin;
	if ('a' <= c && c <= 'z') goto fin;
	c = '_';
fin:
	return c;
}

int main(int argc, const char **argv)
{
	int i, j;
	if (argc >= 2 && argv[1][0] != ':') {
		FILE *fpr = fopen(argv[1], "rb");
		char *p = malloc(64 * 1024);
		if (fpr == NULL || strlen(argv[1]) >= 64 * 1024 - 1) {
			fprintf(stderr, "fopen error: %s\n", argv[1]);
			exit(1);
		}
		for (i = 0; argv[1][i] != '\0'; i++)
			p[i] = funcName(argv[1][i]);
		p[i] = '\0';
		printf("#define persistent\n");
		printf("#include \"%s\"\n", argv[1]);
		printf("void persistent_def(void *p, int size, int grpId, const char *id);\n\n");
		printf("void persistent_default_%s()\n{\n", p);
		mksrc(fpr, stdout);
		printf("}\n");
		free(p);
	}
	if (argc >= 2 && argv[1][0] == ':') {
		printf("void persistent_grp(int grpId, const char *path, const char *tmp, const char *memo);\n\n");
		for (j = 2; j < argc; j++) {
			printf("void persistent_default_");
			for (i = 0; argv[j][i] != '\0'; i++)
				putchar(funcName(argv[j][i]));
			printf("();\n");
		}
		printf("\n");
		printf("void persistent_default()\n");
		printf("{\n");
		printf("\tpersistent_grp(256, \"p-vars.pbd\", \"p-vars_%%x.pbd\", \"(local)\");\n");
		for (j = 2; j < argc; j++) {
			printf("\tpersistent_default_");
			for (i = 0; argv[j][i] != '\0'; i++)
				putchar(funcName(argv[j][i]));
			printf("();\n");
		}
		printf("\treturn;\n");
		printf("}\n");
	}
	return 0;
}

#define MKSRC_BUFSIZ	1024 * 1024
#define VARNAMESIZ		64 * 1024

char *skipSpace(char *p)
{
	while ('\0' < *p && *p <= ' ') p++;
	return p;
}

char matchWord(const unsigned char *p, const char *s)
{
	int len = strlen(s);
	char rc = 1;
	if (strncmp(p, s, len) == 0 && p[len] <= ' ')
		rc = 0;
	return rc;
}

void preprocess(unsigned char *p)
// p[X₷邽߂ɑO(vvZbTƂ͊֌WȂ).
// (1) RgXy[Xɕϊ.
// (2) ̒gXy[Xɂ.
{
	while (*p != '\0') {
		if (*p == '\"') {
			p++;
			while (*p != '\"' && *p != '\0') {
				if (*p == '\\' && p[1] == '\"')
					*p++ = ' ';
				*p++ = ' ';
			}
			continue;
		}
		if (*p == '\'') {
			p++;
			while (*p != '\'' && *p != '\0') {
				if (*p == '\\' && p[1] == '\'')
					*p++ = ' ';
				*p++ = ' ';
			}
			continue;
		}
		if (*p == '/') {
			if (p[1] == '/') {
				*p = '\0';
				continue;
			}
			if (p[1] == '*') {
				*p++ = ' ';
				*p++ = ' ';
				while (!(*p == '*' && p[1] == '/') && *p != '\0')
					*p++ = ' ';
				if (*p != '\0') {
					*p++ = ' ';
					*p++ = ' ';
				}
				continue;
			}
		}
		p++;
	}
	return;
}


char mksrc(FILE *fpr, FILE *fpw)
{
	unsigned char *buf = malloc(MKSRC_BUFSIZ);
	unsigned char *varName = malloc(MKSRC_BUFSIZ);
	char rc = 0, *p, n;
	int i, c;

	for (;;) {
		for (i = 0; i < MKSRC_BUFSIZ - 1; i++) {
			c = fgetc(fpr);
			if (c == EOF) break;
			if (c == '\r') continue;
			if (c == '\n') break;
			buf[i] = c;
		}
		if (i >= MKSRC_BUFSIZ - 1) {
			rc = 1; // too long line.
			goto fin;
		}
		if (i <= 0) break;
		buf[i] = '\0';

		preprocess(buf);
		p = skipSpace(buf);

		/* spersistentɂȂAsꂽǐՂ߂ */
		if (matchWord(p, "persistent") == 0) {
			p = skipSpace(p + 11);
			if (matchWord(p, "struct") == 0)
				p = skipSpace(p + 7);
			while (*p > ' ') p++; // ^ǂݔ΂.
			for (;;) {
				p = skipSpace(p);
				for (i = 0; *p > ' ' && strchr("[=,;*(", *p) == NULL; i++)
					varName[i] = *p++;
				if (i == 0) {
					rc = 2; // syntax error.
					goto fin;
				}
				varName[i] = '\0';
				p = skipSpace(p);
				c = '&';
				if (*p == '[')
					c = ' ';
				fprintf(fpw, "\tpersistent_def(%c%s, sizeof(%s), 256, \"%s\");\n", c, varName, varName, varName);
				n = 0;
				while (*p != '\0' && ((n == 0 && *p != ';' && *p != ',') || n > 0)) {
					if (strchr("([{<", *p) != NULL) n++;
					if (strchr(")]}>", *p) != NULL) n--;
					p++;
				}
				if (*p != ',') break;
				p++;
			}
		}	 
	}
fin:
	free(buf);
	free(varName);
	return rc;
}

